=== debian/changelog ===
intel-compute-runtime (19.39.14278-0ubuntu1) eoan; urgency=medium

  * Upload to eoan.

 -- Timo Aaltonen <tjaalton@debian.org>  Sat, 05 Oct 2019 23:48:44 +0300

intel-compute-runtime (19.39.14278-1) UNRELEASED; urgency=medium

  * New upstream release.
  * control: Migrate to llvm9.
  * control: Bump depends on opencl-clang, intel-graphics-compiler,
    intel-gmmlib.

 -- Timo Aaltonen <tjaalton@debian.org>  Sat, 05 Oct 2019 16:47:31 +0300

intel-compute-runtime (19.29.13530-1) unstable; urgency=medium

  * Initial release (Closes: #926706)

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 01 Aug 2019 12:26:37 +0300
